# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xprinter`](#dsc_xprinter): The DSC xPrinter resource type. Automatically generated from version 1.0.0.2
* [`dsc_xprinterdriver`](#dsc_xprinterdriver): The DSC xPrinterDriver resource type. Automatically generated from version 1.0.0.2
* [`dsc_xprinterport`](#dsc_xprinterport): The DSC xPrinterPort resource type. Automatically generated from version 1.0.0.2

## Resource types

### <a name="dsc_xprinter"></a>`dsc_xprinter`

The DSC xPrinter resource type.
Automatically generated from version 1.0.0.2

#### Properties

The following properties are available in the `dsc_xprinter` type.

##### `dsc_comment`

Data type: `Optional[String]`

Specifies the text to add to the Comment field for the specified printer

##### `dsc_drivername`

Data type: `String`

Specifies the name of the printer driver for the printer

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

 

##### `dsc_location`

Data type: `Optional[String]`

Specifies the location of the printer

##### `dsc_portname`

Data type: `String`

Specifies the name of the port used or created for the printer

##### `dsc_published`

Data type: `Optional[Boolean]`

Specifies whether or not the printer is published in the network directory service

##### `dsc_sharename`

Data type: `Optional[String]`

Specifies the share name of the printer

#### Parameters

The following parameters are available in the `dsc_xprinter` type.

* [`dsc_name`](#-dsc_xprinter--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xprinter--dsc_psdscrunascredential)
* [`name`](#-dsc_xprinter--name)
* [`validation_mode`](#-dsc_xprinter--validation_mode)

##### <a name="-dsc_xprinter--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the printer

##### <a name="-dsc_xprinter--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xprinter--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xprinter--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xprinterdriver"></a>`dsc_xprinterdriver`

The DSC xPrinterDriver resource type.
Automatically generated from version 1.0.0.2

#### Properties

The following properties are available in the `dsc_xprinterdriver` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

 

##### `dsc_environment`

Data type: `Optional[Enum['x86', 'x64']]`

Specifies the printer driver environment

##### `dsc_infpath`

Data type: `Optional[String]`

Specifies the path to the printer driver INF file in the driver store. INF files contain information about the printer and the printer driver

#### Parameters

The following parameters are available in the `dsc_xprinterdriver` type.

* [`dsc_drivername`](#-dsc_xprinterdriver--dsc_drivername)
* [`dsc_psdscrunascredential`](#-dsc_xprinterdriver--dsc_psdscrunascredential)
* [`name`](#-dsc_xprinterdriver--name)
* [`validation_mode`](#-dsc_xprinterdriver--validation_mode)

##### <a name="-dsc_xprinterdriver--dsc_drivername"></a>`dsc_drivername`

namevar

Data type: `String`

Specifies the name of the printer driver

##### <a name="-dsc_xprinterdriver--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xprinterdriver--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xprinterdriver--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xprinterport"></a>`dsc_xprinterport`

The DSC xPrinterPort resource type.
Automatically generated from version 1.0.0.2

#### Properties

The following properties are available in the `dsc_xprinterport` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

 

##### `dsc_printerhostaddress`

Data type: `Optional[String]`

Specifies the host address for the port

##### `dsc_type`

Data type: `Optional[Enum['Local', 'local', 'TCP/IP', 'tcp/ip']]`

 

#### Parameters

The following parameters are available in the `dsc_xprinterport` type.

* [`dsc_name`](#-dsc_xprinterport--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xprinterport--dsc_psdscrunascredential)
* [`name`](#-dsc_xprinterport--name)
* [`validation_mode`](#-dsc_xprinterport--validation_mode)

##### <a name="-dsc_xprinterport--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the port

##### <a name="-dsc_xprinterport--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xprinterport--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xprinterport--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

